/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
Simulator for atomic models.  This calss is used internally.
*/
class DEVSsimulator: public simulator {


public:		DEVSsimulator ();

		virtual void computeNextOutput (stime_t t);
		virtual void reset (stime_t t0 = 0.0);
		virtual void computeIO (stime_t t);
		virtual void computeTransition (stime_t t);
		virtual void input (port_t inport, object* value);
		void setModel (atomic* model);
		virtual ~DEVSsimulator ();

protected:	bool recvd_input;
		atomic* model;
/// Protected constructor for assigning type codes to derived types
		DEVSsimulator (SimType type);

};
