/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
EventReceiver objects are used by the devsn class to describe
to the simulator how messages should be routed.
*/

class EventReceiver: public object {

public:		
/// Creates an event receiver described by the (model, port) pair.
		inline EventReceiver (devs* model, port_t port):
		object () { this->model = model; this->port = port; }
/// Performs a shallow copy.
		inline EventReceiver (const EventReceiver& src):
		object (src) { this->model = src.model; 
				this->port = src.port; }
/// Returns the model that is to receive an event.
		inline devs* getModel () const { return model; }
/// Returns the model's port that should see the event.
		inline port_t getPort () const { return port; }

/// Returns true if the two objects represent the same (model, port) pair.
		virtual bool operator== (const object& obj) const;
		virtual bool operator!= (const object& obj) const;
		virtual unsigned hashcode () const;

private:	
		devs* model;
		port_t port;

};

