/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
The staticDigraph class can be used to create
static structure digraph models.
*/

class staticDigraph: public coupled {

public:		staticDigraph ();
		staticDigraph (const char* name);
/**
Throws an UndefinedException if the model/port pair is
not recognized.
*/
		virtual void couple (devs* src, port_t srcPort,
				devs* dst, port_t dstPort);
/// Support for the simulator.
		const indexed* computeNeighbors (devs& model,
				const port_value& pv);
/// Deletes the digraph model and all of its components.
		virtual ~staticDigraph ();

protected:	digraph* net;
		indexed nodes;

};

