/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/

/**
Define PARALLEL_POSIX if this will be built for parallel simulation
using POSIX threads (pthreads).  Default is no support for parallel
execution.

<p>For persons interested in porting the parallel implementation to
platforms without pthreads, the DEVS/base/parallel directory contain
all of the threading code.  The Mutex and Thread classes 
should be altered as needed.  Additional system headers should
be included in this file.
*/
// #define PARALLEL_POSIX

// Shouldn't need to edit below this line

/**
Include file to get everything in one shot.
*/

#ifndef __ADEVS__
#define __ADEVS__

#include <stdlib.h>
#include <unistd.h>
#ifdef PARALLEL_POSIX
#include <pthread.h>
#endif

// Everything is placed in the adevs namespace
namespace adevs {

#include <adevs/types.h>
#include <adevs/exception.h>
#include <adevs/containers.h>
#include <adevs/DEVS/base.h>
#include <adevs/DEVS/DSDEVS.h>
#include <adevs/DEVS/graphs.h>
#include <adevs/DEVS/DESS.h>
#include <adevs/rand/rand.h>

};

#endif
