/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
A set can contain a single instance of an object.  The set supports
unions and intersections, and equivalence testing.

<p>operators are
<br> + symetric difference
<br> * intersection
<br> - difference
*/
class set: public collection {
	public:
		set():collection() {}
		set(unsigned int capacity, unsigned int grow = DEFAULT_CONTAINER_GROWTH):
		collection(capacity,grow) {}
		set(const set &src):collection(src) {}
		/**
		If the item is already a member of the set,
		the item's current index is returned.
		*/
		void add(object *obj);
		set& operator+=(const set &b);
		set& operator-=(const set &b);
		set& operator*=(const set &b);
		set& assignUnion(const set &b);
		/// The allocated set is the responsibility of the caller
		set* operator+(const set &b) const;
		/// The allocated set is the responsibility of the caller
		set* operator-(const set &b) const;
		/// The allocated set is the responsibility of the caller
		set* operator*(const set &b) const;
		/// The allocated set is the responsibility of the caller
		set* Union(const set &b) const;
		bool operator==(const set &b) const;
		bool operator!=(const set &b) const;
		unsigned int hashcode() const;
		/// Deletes the structure.  Has no effect on elements.
		~set() {}
};
