/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000, 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
Undefined exceptions are used to indicate that an undefined model
or port has been activated by an external event, or that some other
operation has referenced an undefined model or port.
*/

class UndefinedException: public ModelException {

public:		UndefinedException (const devs* model);
		UndefinedException (const devs* model, port_t port);
		UndefinedException (const UndefinedException& src);

		bool undefinedPort () const;
		bool undefinedModel () const;
		
		virtual ~UndefinedException ();

private: 	Port *port;

};
