/***************
Copyright (C) 2001 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/

/**
The crand class provides random number sequences using the standard
C rand() function.  Since the underlying stream generator is rand(),
the state of the random number generator can not be captured with
a call to copy.  Also, each instance of the object samples the same
random number sequence.
*/

class crand: public random_seq {

public:
/// Create a generator with the default seed
		crand () { }
/// Create a generator with the given seed
		crand (unsigned long seed) { srand (seed); }
/// Set the seed for the random number generator
		void set_seed (unsigned long seed) { srand (seed); }
/// Get the next double uniformly distributed in [0, 1]
		double next_dbl () { return (double)rand()/(double)RAND_MAX; } 
/// Copy the random number generator
		random_seq* copy () const { return new crand (); }
/// Destructor
		~crand () { }

};
