/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
/**
A port_t wrapped in an object.
*/

class Port: public object {

public: port_t port;

inline Port ():object () { port = 0; } 
inline Port (port_t p):object () { port = p; } 
inline Port (const Port &src):object (src) { port = src.port; }

inline const Port& operator= (const Port &b) { port = b.port; return *this; }
inline bool operator== (const Port &b) const { return port == b.port; }
inline bool operator!= (const Port &b) const { return port != b.port; }

virtual bool operator== (const object &obj) const;
virtual bool operator!= (const object &obj) const;
virtual unsigned int hashcode () const;

virtual object* clone () const;

~Port ();

}; // end of class port

