/***************
adevs, a library supporting discrete event simulation
Copyright (C) 1999, 2000 James Nutaro

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <string.h>
#include <adevs/adevs.h>
using namespace adevs;

cstr::cstr() { 
	str = new char[strlen("") + 1];
	strcpy(str,"");
}

cstr::cstr(const char* src) {
	str = new char[strlen(src) + 1];
	strcpy(str,src);

}

cstr::cstr(const cstr& src) {
	str = new char[strlen(src.str) + 1];
	strcpy(str,src.str);
}

void cstr::append(const cstr& src) {
	char* tmp = new char[strlen(src.str) + strlen(str) + 1];
	strcpy(tmp,str);
	delete [] str;
	str = tmp;
	strcat(str,src.str);
}

cstr& cstr::operator=(const cstr& src) {
	delete [] str;
	str = new char[strlen(src.str) + 1];
	strcpy(str,src.str);
	return *this;
}

cstr& cstr::operator=(const char* src) {
	delete [] str;
	str = new char[strlen(src) + 1];
	strcpy(str,src);
	return *this;
}

const char* cstr::c_str() const { 
	return str;
}

cstr::~cstr() {
	delete [] str;
}
