#include <adevs/adevs.h>
#include <assert.h>
using namespace adevs;

#define ARRAY_SIZE 100

int main () {

object** keys = new object * [ARRAY_SIZE];
object** values = new object * [ARRAY_SIZE];

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   keys[i] = new object ();
   values[i] = new object ();
   }

hashtable t;

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (t.keyCount () == i);
   t.insert (keys[i], values[i]);
   assert (t.find (*keys[i]) == values[i]);
   }

assert (t.keyCount () == ARRAY_SIZE);
object **keytable = t.getKeys ();

bool found;

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   found = false;
   for (unsigned j = 0; j < ARRAY_SIZE && !found; j++) {
      if (keys[i] == keytable[j]) found = true;
      }
   assert (found);
   assert (t.find (*keys[i]) == values[i]);
   }

hashtable at (t);

t.clear ();
assert (t.keyCount () == 0);

for (unsigned i = 0; i < ARRAY_SIZE / 2; i++) {
   assert (at.remove (*keys[i]) == keys[i]);
   assert (at.find (*keys[i]) == NULL);
   }

assert (at.keyCount () == ARRAY_SIZE - ARRAY_SIZE / 2);
    
for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   at.insert (keys[i], values[i]);
   assert (at.find (*keys[i]) == values[i]);
   }

assert (at.keyCount () == ARRAY_SIZE);

}
   

