#include <adevs/adevs.h>
#include <iostream>
#include <assert.h>
using namespace adevs;

#define ARRAY_SIZE 10

int main () {

cout << "min_priority = " << pqueue::min_priority << endl;

object** objects = new object * [ARRAY_SIZE];
pqueue pq;

assert (pq.minPriority () == pqueue::min_priority);

for (unsigned i = 0; i < ARRAY_SIZE; i++)
   objects[i] = new object ();

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (pq.getSize () == i);
   pq.insert (objects[i], i);
   assert (pq.isEnqueued (*objects[i]));
   assert (pq.getPriority (*objects[i]) == i);
   assert (pq.minPriority () == 0);
   }

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (pq.getSize () == ARRAY_SIZE - i);
   assert (pq.removeMinimum () == objects[i]);
   cout << "removed " << i << endl;
   if (i < ARRAY_SIZE - 1)
      assert (pq.minPriority () == i + 1);
   assert (!pq.isEnqueued (*objects[i]));
   }

cout << endl;
assert (pq.getSize () == 0);

for (unsigned i = ARRAY_SIZE - 1; i > 0; i--) {
   pq.insert (objects[i], i);
   assert (pq.isEnqueued (*objects[i]));
   assert (pq.getPriority (*objects[i]) == i);
   }
 
for (unsigned i = 1; i < ARRAY_SIZE; i++) {
   cout << "size is " << pq.getSize () << endl;
   assert (pq.getSize () == ARRAY_SIZE - i);
   assert (pq.removeMinimum () == objects[i]);
   cout << "removed " << i << endl;
   assert (!pq.isEnqueued (*objects[i]));
   }

cout << endl;
assert (pq.getSize () == 0);

unsigned priorities[ARRAY_SIZE];

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   priorities[i] = i;
   }

srand ((unsigned)&pq);

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (pq.getSize () == i);
   priorities[i] = (unsigned)rand ();
   pq.insert (objects[i], priorities[i]);
   assert (pq.isEnqueued (*objects[i]));
   assert (pq.getPriority (*objects[i]) == priorities[i]);
   }

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   pq.adjust (*objects[i], priorities[i]);
   assert (pq.getPriority (*objects[i]) == priorities[i]);
   }

unsigned min = 0;
unsigned j = 0;

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   object *temp = pq.removeMinimum ();
   for (j = 0; j < ARRAY_SIZE; j++) {
      if (temp == objects[j]) break; 
      }
   cout << "Removed (" << j << ") " << priorities[j] << endl;
   assert (min <= priorities[j]); 
   min = priorities[j];
   }

assert (pq.getSize () == 0);

}   
             

