#include <adevs/adevs.h>
#include <iostream>
#include <assert.h>
#include <math.h>
using namespace adevs;

#define ARRAY_SIZE 10

int main () {

object** objects = new object * [ARRAY_SIZE];
pqueue pq;

for (unsigned i = 0; i < ARRAY_SIZE; i++)
   objects[i] = new object ();

priority_t p;
 
for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   p = fabs ((i + 1) * pqueue::min_priority); 
   assert (pq.getSize () == i);
   pq.insert (objects[i], p);
   assert (pq.isEnqueued (*objects[i]));
   assert (pq.getPriority (*objects[i]) == p);
   assert (pq.minPriority () == fabs (pqueue::min_priority));
   }

for (unsigned i = 0; i < ARRAY_SIZE; i++) {
   assert (pq.getSize () == ARRAY_SIZE - i);
   assert (pq.removeMinimum () == objects[i]);
   cout << "removed " << i << endl;
   if (i < ARRAY_SIZE - 1)
      assert (pq.minPriority () == fabs((i + 2) * pqueue::min_priority));
   assert (!pq.isEnqueued (*objects[i]));
   }

cout << endl;
assert (pq.getSize () == 0);

}
