#include <adevs/adevs.h>
#include "job.h"
#include "genr.h"
using namespace adevs;

const port_t genr::stop = 0;
const port_t genr::start = 1;
const port_t genr::out = 2;
  
genr::genr(stime_t int_arr_time):atomic () {

addInputPort (stop);
addInputPort (start);
addOutputPort (out);
this->int_arr_time = int_arr_time;
count = 0;

}

void genr::reset () {

hold(int_arr_time);
count = 0;

}

void genr::delta_int () {

count = count + 1;
hold(int_arr_time);

}

void genr::delta_ext() {

bag* x = inputOnPort (start);
if (x->getSize() > 0)
   hold (int_arr_time);

x = inputOnPort (stop);
if (x->getSize() > 0)
   passivate();

}

void genr::delta_conf () {

delta_int ();
delta_ext ();

}

void genr::output_func () {

output (out, new job (count));

}

