#include <stdlib.h>
#include <iostream>
#include <adevs/adevs.h>
#include "job.h"
#include "genr.h"
#include "transd.h"
#include "proc.h"
using namespace adevs;

class gpt: public staticDigraph {

public:		gpt (stime_t, stime_t, stime_t);
	
};

gpt::gpt (stime_t genr_period, stime_t proc_time, stime_t obs_int):
staticDigraph () {

genr* g = new genr (genr_period);
transd* t = new transd (obs_int);
proc* p = new proc (proc_time);

add (g);
add (t);
add (p);

couple (g, g->out, t, t->ariv);
couple (g, g->out, p, p->in);
couple (p, p->out, t, t->solved);
couple (t, t->out, g, g->stop);

}

int main () {

stime_t g, p, t;

cout << "Genr period: ";
cin >> g;
cout << "Proc time: ";
cin >> p;
cout << "Observation time: ";
cin >> t;

devssim sim (new gpt (g, p, t));
sim.reset ();
sim.run (); 

exit (0);

}
                                     
