#include <adevs/adevs.h>
#include <stdlib.h>
#include "job.h"
#include "proc.h"
using namespace adevs;

const port_t proc::in = 0;
const port_t proc::out = 1;

proc::proc (stime_t processing_time):atomic() {

addInputPort (in);
addOutputPort (out);
this->processing_time = processing_time;
val = NULL;

}

void proc::reset () {

passivate ();

if (val != NULL) delete val;
val = NULL;

}

void proc::delta_int () {

if (val != NULL) delete val;
val = NULL;
passivate ();

}

void proc::delta_ext () {

bag* x;

if (timeNext() == INFINITY) {
   x = inputOnPort (in);
   val = (job*)x->getObj(x->getSize() - 1)->clone();
   hold (processing_time);
   }

}

void proc::delta_conf () {

delta_int ();
delta_ext ();

}

void proc::output_func () {

output (out, val->clone ());

}

proc::~proc () {

if (val != NULL) delete val;

}
