#include <adevs/adevs.h>
#include "job.h"
#include "transd.h"
#include <stdlib.h>
#include <iostream>
using namespace adevs;

const port_t transd::ariv = 0;
const port_t transd::solved = 1;
const port_t transd::out = 2;

transd::transd (stime_t observation_time):atomic() {

addInputPort (ariv);
addInputPort (solved);
addOutputPort (out);

this->observation_time = observation_time;
total_ta = 0.0;

}

void transd::reset () {

total_ta = 0.0;
_arrived.empty ();
_solved.empty ();
hold (observation_time);

}
 
void transd::delta_int () {

passivate ();

}

void transd::delta_ext () {

job* val;
bag* x;

x = inputOnPort (ariv); 
for (unsigned i = 0; i< x->getSize (); i++) {
   val = (job*)x->getObj(i)->clone ();
   val->t = timeCurrent ();
   _arrived.add(val);
   }

x = inputOnPort (solved); 
for (unsigned i = 0; i< x->getSize (); i++) {
   val = (job*)x->getObj(i);
   unsigned index = _arrived.indexOf (*val);
   val = (job*)_arrived[index]; 
   val = (job*)val->clone ();
   val->t = timeCurrent() - val->t;
   total_ta += val->t;
   val->t = timeCurrent ();
   _solved.add(val);
   }

}

void transd::delta_conf () {

delta_int ();
delta_ext ();

}

void transd::output_func () {

stime_t throughput;
stime_t avg_ta_time;

if (_solved.getSize() != 0) {
   avg_ta_time = total_ta / _solved.getSize();
   if (timeCurrent() > 0)
      throughput = _solved.getSize() / timeCurrent ();
   else throughput = 0.0;
   }
else {
   avg_ta_time = 0.0;
   throughput = 0.0;
   }

cout << "jobs arrived : " << _arrived.getSize () << endl;
cout << "jobs solved : " << _solved.getSize() << endl;

cout << "AVERAGE TA = " << avg_ta_time << endl;
cout << "THROUGHPUT = " << throughput << endl;

output (out, new dbl (throughput));

}

transd::~transd () {

_solved.empty ();
_arrived.empty ();

}
