
/*
The transducer computes various statistics about the
performance of the queuing system.  It receives new jobs
on its ariv port, finished jobs on its solved port,
and generates and output on its out port when the observation
interval has elapsed.
*/
class transd: public adevs::atomic {

public:		transd(adevs::stime_t observ_time);
		void reset ();
		void delta_int ();
		void delta_ext ();
		void delta_conf ();
		void output_func ();
		~transd ();
 
		static const adevs::port_t ariv;
		static const adevs::port_t solved;
		static const adevs::port_t out;

private:	adevs::set _arrived, _solved; 
   		adevs::stime_t total_ta, observation_time;


};

