#include <time.h>
#include <list>
#include <map>
#include <adevs/adevs.h>
#include "types.h"
#include "genr.h"
#include "lb.h"
#include "transd.h"
#include "OS.h"
#include "proc.h"
#include <iostream>
using namespace adevs;

/// Top level model of system architecture
class arch: public staticDigraph {

public:		arch (int num_procs, stime_t time_slice, stime_t obs_time,
			stime_t genr_period, stime_t job_size);

};

arch::arch (int num_procs, stime_t time_slice, stime_t obs_time,
		stime_t genr_period, stime_t job_size):
staticDigraph ("arch") {

OS* e = new OS (num_procs, obs_time, genr_period, job_size);
add (e);

for (int i = 0; i < num_procs; i++) {
   proc* p = new proc (i, time_slice);
   add (p);
   couple (e, e->out, p, p->in);
   couple (p, p->out, e, e->in);
   }

}

int main () {

int num_procs, threads;
stime_t obs_time, genr_period, job_size, time_slice;

std::cout << "Procs: ";
std::cin >> num_procs;
std::cout << "Obs time: ";
std::cin >> obs_time;
std::cout << "Job period: ";
std::cin >> genr_period;
std::cout << "Job size: ";
std::cin >> job_size;
std::cout << "Time slice: ";
std::cin >> time_slice;
std::cout << "Threads: ";
std::cin >> threads;

arch* a = new arch (num_procs, time_slice, 
			obs_time, genr_period, job_size);

// Set the number of threads to use for multiprocessing
devssim::setThreadLimit (threads);
// Start the simulation
devssim sim (a);
// start the timer
time_t t_start = time (NULL);
sim.run ();
// stop the timer
time_t t_end = time (NULL);

std::cout << "Running time: " << difftime (t_end, t_start) << " seconds" << std::endl;
return 0;

}

