#include <adevs/adevs.h>
#include "genr.h"
using namespace adevs;

const port_t genr::out = 0;
const port_t genr::stop = 1;

genr::genr (stime_t period, stime_t job_size, int max_job_count):
atomic ("genr") {

addInputPort (stop);
addOutputPort (out);

setThreaded(false);
this->period = period;
this->job_size = job_size;
this->max_job_count = max_job_count;
count = 0;
next_job_size = 0;

}

void genr::reset () {

count = 0;
next_job_size = r.uniform (0.0, job_size);
hold (r.uniform (0.0, period));

}

void genr::delta_int () {

count++;
if (count >= max_job_count)
   passivate ();
else {
   next_job_size = r.uniform (0.0, job_size);
   hold (r.uniform (0.0, period));
   }

}

void genr::delta_ext () {

passivate ();

}

void genr::delta_conf () {

delta_int ();
delta_ext ();

}

void genr::output_func () {

output (out, new job (count, next_job_size));

}

genr::~genr () {

}
