
#ifndef _TYPES_
#define _TYPES_

// Job description
class job: public adevs::object {

public:
// Job ID
		int jid;
// Processor ID assigned by load balancer
		int pid;
// Timestamp for tracking statistics 
		adevs::stime_t t;

		inline job ():adevs::object () { jid = pid = -1; t = 0.0; }
		inline job (int jid, adevs::stime_t t):adevs::object () {
			pid = -1;
			this->jid = jid;
			this->t = t;
			}
		inline job (const job& src):adevs::object (src) {
			pid = src.pid;
			jid = src.jid;
			t = src.t;
			}
		inline const job& operator=(const job& src) {
			pid = src.pid;
			jid = src.jid;
			t = src.t;
			return *this;
			}
		inline adevs::object* clone () const { return new job (*this); }

};

// Function for comparing jobs based on their job ID's
class compare_jobs {

public:		inline bool operator()(const job& s, const job& t) const {
			return s.jid < t.jid; 
			}

};

#endif
