/***********
Copyright (C) 1999, 2000  James Nutaro

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bugs, comments, and questions can be sent to nutaro@ece.arizona.edu
***************/
#include <adevs/adevs.h>
#include <stdlib.h>

/**

Message class is used to represent an operation that should be
performed.

*/

using namespace adevs;

class message: public object {

public:	inline message ():object () { pid = mid = c = 0; control = false; }
	inline message (unsigned pid, unsigned mid):object () { 
		this->mid = mid; this->pid = pid; c = 0; control = false; }
	inline message (unsigned pid, unsigned mid, unsigned c):object () { 
	   this->pid = pid; this->mid = mid; this->c = c; control = false; }
	inline message (const message& src):object (src) {
	   this->pid = src.pid; this->c = src.c; this->mid = src.mid; control = src.control;
	   }
	inline message& operator=(const message& src) {
	   this->pid = src.pid; this->c = src.c; this->mid = src.mid; control = src.control;
	   return *this;
	   }
	inline bool operator>(const message& src) const {
	   if (c == src.c) return (pid > src.pid);
	   else return (c > src.c);
	   }
	inline bool operator<(const message& src) const {
	   if (c == src.c) return (pid < src.pid);
	   else return (c < src.c);
	   }
	inline bool operator==(const message& src) const {
	   return (c == src.c && pid == src.pid && 
			mid == src.mid && control == src.control);
	   }
	~message () { }

	unsigned pid, mid, c;
	bool control;

};

