#include <adevs/adevs.h>
#include <iostream>
#include <assert.h>
#include "counter.h"
#include "genr.h"
#include "delay.h"
#include "gcd.h"
using namespace adevs;

/**

Test targets the behavior of the computeNextOutput function
for more complex models than in the genr and deepgenr tests.

*/

// special simulator to test computeNextOutput function

class _devssim: public devssim {

public:		_devssim (coupled* model);
		virtual bool halt ();

private:	int count;
};

_devssim::_devssim (coupled* model):devssim (model) { count = 0; }

bool _devssim::halt () {

indexed results;
computeNextOutput (results);

if ((int)timeNext() % 2 == 1 && (int)timeNext() != 1 && timeNext () < INFINITY) {
   count++;
   port_value* pv = (port_value*)results[0];
   intg* i = (intg*)pv->value;
   std::cout << i->value << std::endl;
   std::cout << pv->port << std::endl;
   assert (results.getSize() == 1);
   assert (i->value == count);
   }

else assert (results.getSize() == 0);

return devssim::halt ();

}

// end of class _devssim

class t: public staticDigraph {

public:		t ();
		~t ();

		static const port_t out;

};

const port_t t::out = 0;

t::t ():staticDigraph () {

gcd* c = new gcd (10, 1, 1, false);
gcd* g = new gcd (2, 2, 10, true);

add (c);
add (g);

addOutputPort (out);
couple (g, g->signal, c, c->in);
couple (c, c->out, this, this->out);

}

t::~t () { }

int main () {

std::cout << "Test 9" << std::endl;

_devssim sim (new t ());
sim.reset ();
sim.run ();

std::cout << "Test done" << std::endl;

}
