
class obj_ptr: public adevs::object {

public:		adevs::object* value;
		obj_ptr (adevs::object* obj):adevs::object() { this->value = obj; }

};

class genr: public adevs::atomic {

public:

	const static adevs::port_t out;

	genr (adevs::stime_t period, adevs::object* id):adevs::atomic() {
		this->period = period;
		this->id = id;
		addOutputPort (out);
		}
	void reset () {
		hold (period);
		}
	void delta_int () { hold (period); }
	void delta_ext () { }
	void delta_conf () { }
	void output_func () { output (out, new obj_ptr (id)); }

private:
	adevs::stime_t period;
	adevs::object* id;
 
};

class cell: public adevs::staticDigraph {

public:
	const static adevs::port_t die;
	const static adevs::port_t birth;

	cell ():adevs::staticDigraph () {
		genr* life = new genr (2.0, this);
		genr* reproduction = new genr (1.0, this);
		addOutputPort (die);
		addOutputPort (birth);
		add (life);
		add (reproduction);
		couple (life, life->out, this, die);
		couple (reproduction, reproduction->out, this, birth);
		pop++;
		}
	~cell () { pop--; }

	static int getPop () { return pop; }

private:
	static int pop;

};

